/** 
 * FactorySimulation -- set up the whole simulation,
 * including creation of the Trucks and Distributors.
 **/
public class FactorySimulation extends DESimulation {
  
  private FactoryProduct factory;
  
  /**
   * Accessor for factory
   **/
  public FactoryProduct getFactory(){return factory;}
  
  public void setUp(){
    // Let the world be setup
    super.setUp();
    // Give the world a reasonable background
    FileChooser.setMediaPath("D:/cs1316/MediaSources/");
    world.setPicture(new Picture(
                   FileChooser.getMediaPath("EconomyBackground.jpg")));
    
    // Create a factory resource
    factory = new FactoryProduct(); //Track factory product
    
    // Create three trucks
    Truck myTruck = null;
    for (int i=0; i<4; i++){
      myTruck = new Truck(world,this);
      myTruck.setName("Truck: "+i);}

    // Create five Distributors
    Distributor sales = null;
    for (int i=0; i<5; i++){
      sales = new Distributor(world,this);
      sales.setName("Distributor: "+i);}
  }
}
