import jm.music.data.*;
import jm.JMC;
import jm.util.*;
import jm.music.tools.*;
 
public class MVAmazingGraceSong {
  private Score myScore = new Score("Amazing Grace");
  
  public Score getScore() {
    return myScore;
  };
  
  public void fillMeUp(){
    myScore.setTimeSignature(3,4);
    
   double[] phrase1data = 
   {JMC.G4, JMC.QN,
     JMC.C5, JMC.HN, JMC.E5,JMC.EN, JMC.C5,JMC.EN,
     JMC.E5,JMC.HN,JMC.D5,JMC.QN,
     JMC.C5,JMC.HN,JMC.A4,JMC.QN,
     JMC.G4,JMC.HN,JMC.G4,JMC.EN,JMC.A4,JMC.EN,
     JMC.C5,JMC.HN,JMC.E5,JMC.EN,JMC.C5,JMC.EN,
     JMC.E5,JMC.HN,JMC.D5,JMC.EN,JMC.E5,JMC.EN,
     JMC.G5,JMC.DHN};
   double[] phrase2data =
   {JMC.G5,JMC.HN,JMC.E5,JMC.EN,JMC.G5,JMC.EN,
     JMC.G5,JMC.HN,JMC.E5,JMC.EN,JMC.C5,JMC.EN,
     JMC.E5,JMC.HN,JMC.D5,JMC.QN,
     JMC.C5,JMC.HN,JMC.A4,JMC.QN,
     JMC.G4,JMC.HN,JMC.G4,JMC.EN,JMC.A4,JMC.EN,
     JMC.C5,JMC.HN,JMC.E5,JMC.EN,JMC.C5,JMC.EN,
     JMC.E5,JMC.HN,JMC.D5,JMC.QN,
     JMC.C5,JMC.DHN
   };
   
   //
   Phrase trumpetPhrase = new Phrase();
   trumpetPhrase.addNoteList(phrase1data); // 22.0 beats long
   double endphrase1 = trumpetPhrase.getEndTime();
   System.out.println("End of phrase1:"+endphrase1);
   trumpetPhrase.addNoteList(phrase2data);
   // create a new part and add the phrase to it
   Part part1 = new Part("TRUMPET PART", 
                         JMC.TRUMPET, 1);
   part1.addPhrase(trumpetPhrase);
   // add the part to the score
   myScore.addPart(part1);
   //
   Phrase flutePhrase = new Phrase(endphrase1);
   flutePhrase.addNoteList(phrase1data); // 22.0 beats long
   flutePhrase.addNoteList(phrase2data); // optionally, remove this
   // create a new part and add the phrase to it
   Part part2 = new Part("FLUTE PART", 
                         JMC.FLUTE, 2);
   part2.addPhrase(flutePhrase);
   // add the part to the score
   myScore.addPart(part2);

   
  };
  
  public void showMe(){
       
   View.notate(myScore);
  };
  
}
