/**
 * A GUI that has various components in it, to demonstrate
 * UI components and layout managers (rendering).
 * Now with Interactivity!
 **/
import javax.swing.*; // Need this to reach Swing components
import java.awt.*; // Need this to reach FlowLayout
import java.awt.event.*; // Need this for listeners and events

public class PictureTool extends JFrame {
  
  Picture myPic;
  
  public PictureTool(String picPath){
    super("Control for "+picPath);
    
    myPic = new Picture(picPath);
    myPic.show();
    
    this.getContentPane().setLayout(new BorderLayout());
    /* Put in a panel with a label in it */
    JPanel panel1 = new JPanel();
    this.getContentPane().add(panel1);
    JLabel label = new JLabel("Use these tools ");
    panel1.add(label,BorderLayout.NORTH);
    
    /* Put in another panel with two buttons in it */
    JPanel panel2 = new JPanel();
    this.getContentPane().add(panel2,BorderLayout.SOUTH);
    JButton button1 = new JButton("Darken");
    button1.addActionListener(
      new ActionListener() { 
        public void actionPerformed(ActionEvent e) {
           myPic.darken();
           myPic.repaint();
        }
      }
    );
    panel2.add(button1);
    
     JButton button2 = new JButton("Grayscale");
    button2.addActionListener(
      new ActionListener() { 
        public void actionPerformed(ActionEvent e) {
           myPic.grayscale();
           myPic.repaint();
        }
      }
    );
     panel2.add(button2);

      this.pack();
    this.setVisible(true);
  }
  
}
