/**
 * A Rhythm-constructing tool
 **/
import javax.swing.*; // Need this to reach Swing components
import java.awt.*; // Need this to reach FlowLayout
import java.awt.event.*; // Need this for listeners and events

public class RhythymTool extends JFrame {
  
  /* Base of sound that we're creating */
  public SoundElement root;
  /* Sound that we're creating to add in. */
  public SoundElement newSound;
  /* Declare these here so we can reach them inside listeners */
  private JTextField filename;
  private JTextField count;
  int num;
  
  public RhythymTool(){
    super("Rhythm Tool");
    FileChooser.setMediaPath("D:/cs1316/mediasources/"); //CHANGE ME!
    
    root = new SoundElement(new Sound(1)); // Nearly empty sound
    newSound = new SoundElement(new Sound(1)); // Ditto
    
    this.getContentPane().setLayout(new BorderLayout());
    /* First panel has new sound field */
    JPanel panel1 = new JPanel();
    this.getContentPane().add(panel1,BorderLayout.NORTH);
    filename = new JTextField("soundfilename.wav");
    filename.addActionListener(
      new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        newSound = new SoundElement(
                       new Sound(
                        FileChooser.getMediaPath(filename.getText())));
        System.out.println("New sound from "+
                           FileChooser.getMediaPath(filename.getText()));
      }
    }
    );
    panel1.add(filename);
    
    /* Put in another panel with number field 
     * and repeat & weave buttons */
    JPanel panel2 = new JPanel();
    panel2.setLayout(new BorderLayout());
    this.getContentPane().add(panel2,BorderLayout.CENTER);
    count = new JTextField("100");
    count.addActionListener(
      new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        // Here's how we convert a string to a number
        num = Integer.parseInt(count.getText());
      }
    }
    );
    panel2.add(count,BorderLayout.NORTH);
    // Now do the Repeat button
    JButton button1 = new JButton("Repeat");
    button1.addActionListener(
      new ActionListener() { 
        public void actionPerformed(ActionEvent e) {
           root.repeatNext(newSound,num);
        }
      }
    );
    panel2.add(button1,BorderLayout.EAST);
    // Now do the Weave button
    JButton button2 = new JButton("Weave");
    button2.addActionListener(
      new ActionListener() { 
        public void actionPerformed(ActionEvent e) {
          // We'll weave 10 copies in
          // every num times
           root.weave(newSound,10,num);
        }
      }
    );
    panel2.add(button2,BorderLayout.WEST);
    
    /* Put in another panel with the Play button */
    JPanel panel3 = new JPanel();
    this.getContentPane().add(panel3,BorderLayout.SOUTH);
    JButton button3 = new JButton("Play");
    button3.addActionListener(
      new ActionListener() { // Here's the listener
        // Here's the method we're overriding
        public void actionPerformed(ActionEvent e) {
           root.playFromMeOn();
        }
      }
    );
     panel3.add(button3);

      this.pack();
    this.setVisible(true);
  }
  
}
